{
 -------------------------------------------------------------------------
 Copyright (C) 2001-2003 Hger+Busch                   / >>>>>>>>> /-----
 Ingenieurbuero fuer Kommunikationslsungen           / <<<<<<<<< /
 ----------------------------------------------------/ >>>>>>>>> /
 All rights reserved.
                                                    http://www.commso.com

 Project     : hbTapi Components
 Modul       : MakeCallSample v1.0

 Description : This sample shows how to make a call with a special media mode.

 History     : [-] Fixed [+] Added [*] Improved

 08/19/03   Creation
}
unit uMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Tapi, ExtCtrls, hbTAPI, hbTAPIUtils;

type
  TForm1 = class(TForm)
    LabelCallerIDNumber: TLabel;
    EditPhoneNo: TEdit;
    LabelDevice: TLabel;
    ComboBox_Device: TComboBox;
    TapiLine1: TTapiLine;
    ComboBox_MediaMode: TComboBox;
    Label1: TLabel;
    Button1: TButton;
    Label2: TLabel;
    Button2: TButton;
    ListBox1: TListBox;
    ComboBox_Address: TComboBox;
    Label3: TLabel;
    CheckBox_SyncMode: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure ComboBox_DeviceChange(Sender: TObject);
    procedure TapiLine1CallState(Sender: TTapiLine; Call: TTapiCall;
      CallState: Cardinal);
    procedure DoMakeCall(Sender: TObject);
    procedure TapiLine1CallEnd(Sender: TTapiLine; Call: TTapiCall);
    procedure DoDropCall(Sender: TObject);
    procedure TapiLine1CallerID(Sender: TTapiLine; Call: TTapiCall);
    procedure TapiLine1CalledID(Sender: TTapiLine; Call: TTapiCall);
    procedure TapiLine1CallDeallocate(Sender: TTapiLine; Call: TTapiCall);
    procedure TapiLine1ConnectedID(Sender: TTapiLine; Call: TTapiCall);
    procedure TapiLine1RedirectingID(Sender: TTapiLine; Call: TTapiCall);
    procedure TapiLine1RedirectionID(Sender: TTapiLine; Call: TTapiCall);
    procedure TapiLine1TapiReply(Sender: TObject; RequestID,
      ReplyCode: Cardinal);
    procedure TapiLine1TapiTimeout(Sender: TObject; RequestID: Cardinal);
    procedure CheckBox_SyncModeClick(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
  private
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  TapiLine1.Options.SyncMode := CheckBox_SyncMode.Checked;
  // Fill in the ComboBox with all available telephony line devices
  ComboBox_Device.Items.Assign(TapiLine1.DeviceList);
  if ComboBox_Device.Items.Count > 0 then
    ComboBox_Device.Items.Insert(0, '- none -')
  else
    ComboBox_Device.Items.Add('- none -');

  ComboBox_Device.ItemIndex := 0;
end;

procedure TForm1.ComboBox_DeviceChange(Sender: TObject);
begin
  // If TapiLine is currently open then close it
  TapiLine1.Active := False;

  // Set the TapiLine.DeviceID to use the device selected in the list box
  TapiLine1.DeviceID := ComboBox_Device.ItemIndex-1;

  if not TapiLine1.Available then
  begin
    ComboBox_MediaMode.Items.Clear;
    Combobox_Address.Items.Clear;
    Exit;
  end;

  // If there was a problem opening TapiLine last time then make sure that the
  // following properties are reset to their default.
  TapiLine1.Privileges.Monitor := TRUE;
  TapiLine1.Privileges.Owner   := TRUE;

  // Fill in the ComboBox with all supporting media modes.
  LineMediaModesToStrList(TapiLine1.Caps.MediaModes, ComboBox_MediaMode.Items);
  if ComboBox_MediaMode.Items.Count > 0 then
    ComboBox_MediaMode.ItemIndex := 0;

  Combobox_Address.Items.Assign(TapiLine1.AddressList);
  if ComboBox_Address.Items.Count > 0 then
    ComboBox_Address.ItemIndex := 0;

  try
    TapiLine1.Active := True;
//    ListBox1.Items.add(Format('Line is opened %d times',[TapiLine1.Status.NumOpens]));
  except
    on E:ETapiError do
      case E.ErrorCode of
         LINEERR_INVALMEDIAMODE :
         begin
           try
             TapiLine1.Privileges.Owner := FALSE;
             TapiLine1.Active := True;
           except
             on E:Exception do
               MessageDlg('Error opening line device: ' + E.Message, mtError, [mbOk],0);
           end;
           MessageDlg('This device is not 100% TAPI compliant',mtWarning, [mbOk],0);
         end;
      else  // Time for a little error checking
        MessageDlg('Error opening line device: ' + E.Message, mtError, [mbOk],0);
      end;
  end;
end;

procedure TForm1.TapiLine1CallState(Sender: TTapiLine; Call: TTapiCall;
  CallState: Cardinal);
var s: String;
begin
  ListBox1.Items.Add('::OnCallState (' + Call.StateText + ')');
  if Call.CallerID.AddressAvail then
  begin
    s := Call.CallerID.Address;
    ListBox1.Items.Add('CallerID Address = ' + Call.CallerID.Address);
  end;
(* Feature of hbTapi Professional
  if Call.RemoteID.AddressAvail then
  begin
    s := Call.RemoteID.Address;
    ListBox1.Items.Add('Remote Address = ' + Call.RemoteID.Address);
  end;
  if Call.RemoteID.NameAvail then
    ListBox1.Items.Add('Remote Name = ' + Call.RemoteID.Name);
*)
end;

procedure TForm1.DoMakeCall(Sender: TObject);
begin
  try
    TapiLine1.CallParams.MediaMode := StrToLineMediaMode(ComboBox_MediaMode.Text);
    TapiLine1.CallParams.AddressID := ComboBox_Address.ItemIndex;
    ListBox1.Items.Add('Calling TapiLine1.MakeCall...');
    TapiLine1.MakeCall(EditPhoneNo.Text);
    if TapiLine1.options.SyncMode then
      ListBox1.Items.Add('MakeCall returned.')
    else
      ListBox1.Items.Add('MakeCall returned. LastRequestID= 0x' + IntToHex(TapiLine1.LastRequestID, 2));
  except
    on E:ETapiError do
      MessageDlg('MakeCall failed!' + E.Message, mtError, [mbok], 0);
  end;
end;

procedure TForm1.TapiLine1CallEnd(Sender: TTapiLine; Call: TTapiCall);
begin
  ListBox1.Items.Add('::OnCallEnd');
end;

procedure TForm1.DoDropCall(Sender: TObject);
begin
  if TapiLine1.Calls.count > 0 then
  begin
    ListBox1.Items.Add('Calling Call.Drop...');
    TapiLine1.Calls[0].Drop;
    if TapiLine1.options.SyncMode then
      ListBox1.Items.Add('Call.Drop returned')
    else
      ListBox1.Items.Add('Drop returned. LastRequestID = 0x' + IntToHex(TapiLine1.LastRequestID, 2));
  end;
end;

procedure TForm1.TapiLine1CallerID(Sender: TTapiLine; Call: TTapiCall);
begin
  ListBox1.Items.Add('::OnCallerID (' + Call.CallerID.Address + ', ' + Call.CallerID.Name + ')');
  if Call.CallerID.AddressAvail then
    ListBox1.Items.Add('Caller Address = ' + Call.CallerID.Address);
  if Call.CallerID.NameAvail then
    ListBox1.Items.Add('Caller Name = ' + Call.CallerID.Name);
end;

procedure TForm1.TapiLine1CalledID(Sender: TTapiLine; Call: TTapiCall);
begin
//  Feature of hbTapi Professional
(*
  ListBox1.Items.Add('::OnCalledID (' + Call.CalledID.Address + ', ' + Call.CalledID.Name + ')');
  if Call.CalledID.AddressAvail then
    ListBox1.Items.Add('Called Address = ' + Call.CalledID.Address);
  if Call.CalledID.NameAvail then
    ListBox1.Items.Add('Called Name = ' + Call.CalledID.Name);
*)
end;

procedure TForm1.TapiLine1CallDeallocate(Sender: TTapiLine;
  Call: TTapiCall);
begin
  ListBox1.Items.Add('::OnCallDeallocate');
end;

procedure TForm1.TapiLine1ConnectedID(Sender: TTapiLine; Call: TTapiCall);
begin
// Feature of hbTapi Professional
(*
 ListBox1.Items.Add('::OnConnectedID (' + Call.ConnectedID.Address + ', ' + Call.ConnectedID.Name + ')');
  if Call.RemoteID.AddressAvail then
    ListBox1.Items.Add('Remote Address = ' + Call.RemoteID.Address);
  if Call.RemoteID.NameAvail then
    ListBox1.Items.Add('Remote Name = ' + Call.RemoteID.Name);
*)
end;

procedure TForm1.TapiLine1RedirectingID(Sender: TTapiLine;
  Call: TTapiCall);
begin
// Feature of hbTapi Enterprise
(*
  ListBox1.Items.Add('::OnRedirecingID (' + Call.RedirectingID.Address + ')');
  if Call.RemoteID.AddressAvail then
    ListBox1.Items.Add('Remote Address = ' + Call.RemoteID.Address);
  if Call.RemoteID.NameAvail then
    ListBox1.Items.Add('Remote Name = ' + Call.RemoteID.Name);
*)
end;

procedure TForm1.TapiLine1RedirectionID(Sender: TTapiLine;
  Call: TTapiCall);
begin
// Feature of hbTapi Enterprise
(*
  ListBox1.Items.Add('::OnRedirectionID (' + Call.RedirectionID.Address + ')');
  if Call.RemoteID.AddressAvail then
    ListBox1.Items.Add('Remote Address = ' + Call.RemoteID.Address);
  if Call.RemoteID.NameAvail then
    ListBox1.Items.Add('Remote Name = ' + Call.RemoteID.Name);
*)
end;

procedure TForm1.TapiLine1TapiReply(Sender: TObject; RequestID,
  ReplyCode: Cardinal);
begin
  if TapiLine1.Options.SyncMode = FALSE then
    ListBox1.Items.Add(Format('::OnTapiReply RequestID=0x%X, ReplyCode=0x%X',[RequestID, ReplyCode]));
end;

procedure TForm1.TapiLine1TapiTimeout(Sender: TObject;
  RequestID: Cardinal);
begin
  if TapiLine1.Options.SyncMode = FALSE then
    ListBox1.Items.Add(Format('::OnTapiTimeout RequestID=0x%X',[RequestID]));
end;

procedure TForm1.CheckBox_SyncModeClick(Sender: TObject);
begin
  TapiLine1.Options.SyncMode := CheckBox_SyncMode.Checked;
end;

procedure TForm1.ListBox1DblClick(Sender: TObject);
begin
  ListBox1.Items.Clear;
end;

end.
